import React, {Component} from "react";
import CoursesListType from '../coursesPublic/CoursesListType';
import {WordsBtn, ActionBtn} from 'educoder';
import {
	Table,
	Pagination,
} from "antd";
import {Link} from 'react-router-dom';
import axios from 'axios';
import moment from 'moment';
import '../css/members.css'
import '../css/busyWork.css'
import '../poll/pollStyle.css'
import {getImageUrl} from 'educoder';
import TraineetraininginformationModal from "./TraineetraininginformationModal";
import Startshixuntask from "../coursesPublic/Startshixuntask";


//GraduationTaskssetting.js

//作品列表(学生)
class Listofworksstudentone extends Component {
	//unifiedsetting 统一设置
	//allowreplenishment 允许补交
	//completionefficiencyscore 完成效率评分占比
	//level级别
	//proportion 比例
	constructor(props) {
		super(props);
		// course_group_info  老师身份显示的分班情况
		//task_status 老师身份显示的提交情况
		//要提交的作品状态checkedValuesine
		//要提交的分班状态checkedValuesineinfo
		//searchtext 输入的姓名和学号
		//order 排序时间
		this.state = {
			jobsettingsdata: undefined,
			endTime: "2018/11/10 17:10:00",
			type: "day",
			props: props,
			data: [],
			datas: [],
			page: 1,
			pages: 1,
			limit: 20,
			loadingstate: true,
			order: "updated_at",
			search: null,
			day: 0,
			hour: 0,
			minute: 0,
			second: 0,
			userids: 0,
			viewtrainingdata: {},
			teacherdata: undefined,
			task_status: [],
			visibles: false,
			course_group_info: [],
			styletable: {
				"display": "none"
			},
			student_works: [],
			startbtn: false
		}
		//
	}

	componentDidMount() {

		var homeworkid = this.props.match.params.homeworkid;
		this.Getalistofworks(homeworkid);
		let query = this.props.location.pathname;
		const type = query.split('/');
		this.setState({
			shixuntypes: type[3]
		})
	}


	//卸载组件取消倒计时
	componentWillUnmount() {
		// clearInterval(this.timer);
	}

	// 获取作品列表
	Getalistofworks = (homeworkid) => {
		// console.log("获取作品列表");

		let urll = `/homework_commons/${homeworkid}/works_list.json`;
		var data = {
			search: "",
			order: "",
			b_order: "",
			work_status: "",
			course_group: "",
		}
		axios.post(urll, data).then((result) => {
			if (result.status === 200) {
				this.setState({
					teacherdata: result.data,
					task_status: result.data.task_status,
					course_group_info: result.data.course_group_info,
					student_works: result.data.student_works,
					jobsettingsdata: result,
					publish_immediately: result.data.publish_immediately,
					end_immediately: result.data.end_immediately,
					id: result.data.id,
				})
				if (result.data.student_works === undefined || result.data.student_works === null || JSON.stringify(result.data.student_works) === "[]") {
					this.seacthdata();
				} else {
					this.seacthdatas();
				}

			}
		}).catch((error) => {
			console.log(error)
		})
	}

// 获取作品列表
	Getalistofworkstwo = (ordervlue, checkedValuesine, checkedValuesineinfo, searchtext, page, limit) => {
		// console.log("获取作品列表");
		var homeworkid = this.props.match.params.homeworkid;
		let urll = `/homework_commons/${homeworkid}/works_list.json`;
		// console.log(homeworkid);

		// search:搜索关键字
		// order:排序方式：更新时间：update_time，最终成绩：work_score，学号：student_id
		// b_order:desc：倒序 ， asc：顺序
		// work_status:0:未提交， 1:按时提交， 2:延时提交，“”不限
		// course_group:分班情况 [232, 231]， []:不限（空数组）
		var order = "asc";
		if (ordervlue === "updated_at") {
			order = "desc";
		}
		var data = {
			search: "",
			order: ordervlue,
			b_order: order,
			work_status: "",
			course_group: "",
			page: page,
			limit: limit,
		}
		axios.post(urll, data).then((result) => {
			if (result.status === 200) {
				// console.log("学生未截至未公开的作品列表")
				// console.log(JSON.stringify(result))
				this.setState({
					teacherdata: result.data,
					task_status: result.data.task_status,
					course_group_info: result.data.course_group_info,
					student_works: result.data.student_works,
				})
				if (result.data.student_works === undefined || result.data.student_works === null || JSON.stringify(result.data.student_works) === "[]") {
					this.seacthdata();
				} else {
					this.seacthdatas();
				}

			}
		}).catch((error) => {
			console.log(error)
			this.setState({
				loadingstate:false
			})
		})
	}
	TablePagination = (e) => {
		// console.log(e.current);
		this.setState({
			page: e.current
		})

	}

	seacthdatas = () => {
		let {page, limit} = this.state;
		let datalist = [];
		let datalists = [];
		var styletable = {"display": "none"}

		// console.log("seacthdata设置数据3")

		var teacherlist = undefined;
		var teacherlists = undefined;
		if (this.state.teacherdata !== undefined) {
			// console.log("seacthdata设置数据")
			// console.log(this.state.teacherdata.id )
			if (this.state.teacherdata.id === undefined) {
				this.setState({
					data: [],
					teacherlist: undefined,
					loadingstate: false,
					styletable: styletable,
				})

			} else {
				console.log(this.state.teacherdata)
				if (this.state.teacherdata.id !== undefined || this.state.teacherdata.id !== null || this.state.teacherdata.id !== "") {
					// console.log("seacthdata设置数据1")
					// console.log(this.state.teacherdata )
					var timedata = moment(this.state.teacherdata.update_time).format('YYYY-MM-DD HH:mm');
					datalist.push({
						myid: this.state.teacherdata.id,
						number: 1,
						name: this.state.teacherdata.user_name,
						stduynumber: this.state.teacherdata.student_id,
						classroom: this.state.teacherdata.group_name,
						submitstate: this.state.teacherdata.work_status === 0 ? "未提交" : this.state.teacherdata.work_status === 1 ? "按时提交" : this.state.teacherdata.work_status === 2 ? "延时提交" : "未提交",
						// updatetime:this.state.teacherdata.student_works[i].update_time,
						// updatetime:"",
						updatetime: timedata === "Invalid date" ? "--" : timedata,
						completion: this.state.teacherdata.complete_count === 4 ? "4/4" : this.state.teacherdata.complete_count === 3 ? "3/4" : this.state.teacherdata.complete_count === 2 ? "2/4" : this.state.teacherdata.complete_count === 1 ? "1/4" : this.state.teacherdata.complete_count === 0 ? "0" : 0,
						levelscore: this.state.teacherdata.final_score,
						efficiencyscore: this.state.teacherdata.eff_score,
						finalscore: this.state.teacherdata.work_score,
						operating: "查看",
					})

					// }
					var teacherlist = {  //分页
						total: this.state.teacherdata.student_works.length, //数据总数量
						pageSize: this.state.teacherdata.student_works.length,  //一页显示几条
						current: this.state.page,
					}
					styletable = {"display": "block",}
				} else {
					// console.log("seacthdata设置数据2")
					teacherlist = undefined;

				}
			}

		}


		if (this.state.student_works !== undefined) {

			for (var i = 0; i < this.state.student_works.length; i++) {

				var timedata = moment(this.state.student_works[i].update_time).format('YYYY-MM-DD HH:mm');
				datalists.push({
					myid: this.state.student_works[i].id,
					number: (parseInt(page) - 1) * parseInt(limit) + (i + 1),
					name: this.state.student_works[i].user_name,
					stduynumber: this.state.student_works[i].student_id,
					classroom: this.state.student_works[i].group_name,
					submitstate: this.state.student_works[i].work_status === 0 ? "未提交" : this.state.student_works[i].work_status === 1 ? "按时提交" : this.state.student_works[i].work_status === 2 ? "延时提交" : "未提交",
					// updatetime:this.state.teacherdata.student_works[i].update_time,
					// updatetime:"",
					updatetime: timedata === "Invalid date" ? "--" : timedata,
					completion: this.state.student_works[i].complete_count === 4 ? "4/4" : this.state.student_works[i].complete_count === 3 ? "3/4" : this.state.student_works[i].complete_count === 2 ? "2/4" : this.state.student_works[i].complete_count === 1 ? "1/4" : this.state.student_works[i].complete_count === 0 ? "0" : 0,
					levelscore: this.state.student_works[i].final_score,
					efficiencyscore: this.state.student_works[i].eff_score,
					finalscore: this.state.student_works[i].work_score,
					operating: "查看",
				})

			}

			/*teacherlists = {  //分页
				total: this.state.student_works.length, //数据总数量
				pageSize: 10,  //一页显示几条
				current: this.state.pages,
			}*/


		}


		this.setState({
			data: datalist,
			datas: datalists,
			teacherlist: teacherlist,
			teacherlists: teacherlists,
			loadingstate: false,
			styletable: styletable,
		})
	}
	// 设置数据
	seacthdata = () => {
		let datalist = [];
		if (this.state.teacherdata !== undefined) {
			// console.log("seacthdata设置数据")
			// console.log(this.state.teacherdata.id )
			if (this.state.teacherdata.id === undefined) {
				this.setState({
					data: [],
					teacherlist: undefined,
					loadingstate: false,
				})
				return
			}
			// console.log(this.state.teacherdata )
			if (this.state.teacherdata.id !== undefined || this.state.teacherdata.id !== null || this.state.teacherdata.id !== "") {
				// console.log("seacthdata设置数据1")
				// console.log(this.state.teacherdata )
				var timedata = moment(this.state.teacherdata.update_time).format('YYYY-MM-DD HH:mm');
				datalist.push({
					myid: this.state.teacherdata.id,
					number: 1,
					name: this.state.teacherdata.user_name,
					stduynumber: this.state.teacherdata.student_id,
					classroom: this.state.teacherdata.group_name,
					submitstate: this.state.teacherdata.work_status === 0 ? "未提交" : this.state.teacherdata.work_status === 1 ? "按时提交" : this.state.teacherdata.work_status === 2 ? "延时提交" : "未提交",
					// updatetime:this.state.teacherdata.student_works[i].update_time,
					// updatetime:"",
					updatetime: timedata === "Invalid date" ? "--" : timedata,
					completion: this.state.teacherdata.complete_count === 4 ? "4/4" : this.state.teacherdata.complete_count === 3 ? "3/4" : this.state.teacherdata.complete_count === 2 ? "2/4" : this.state.teacherdata.complete_count === 1 ? "1/4" : this.state.teacherdata.complete_count === 0 ? "0" : 0,
					levelscore: this.state.teacherdata.final_score,
					efficiencyscore: this.state.teacherdata.eff_score,
					finalscore: this.state.teacherdata.work_score,
					operating: "查看",
				})

				// }
				var teacherlist = {  //分页
					total: this.state.teacherdata.student_works.length, //数据总数量
					pageSize: this.state.teacherdata.student_works.length,  //一页显示几条
					current: this.state.page,
				}
			} else {
				// console.log("seacthdata设置数据2")
				var teacherlist = undefined;

			}
		} else {
			// console.log("seacthdata设置数据3")

			var teacherlist = undefined;
		}
		console.log("datalistdatalist文件");
		console.log(datalist);
		this.setState({
			data: datalist,
			teacherlist: teacherlist,
			loadingstate: false,
		})
	}
	// 查看学员实训信息
	Viewstudenttraininginformation = (e) => {
		// console.log("Listofworksstudentone.js");
		// console.log(e);
		this.setState({
			userids: e.myid,
		})
		this.viewtraining(e.myid);
	}
	viewtraining = (userids) => {
		// console.log("viewtraining")
		// console.log(userids)
		// console.log(JSON.stringify(this.props.user))
		var url = `/student_works/${userids}/shixun_work.json`;
		axios.get(url).then((result) => {
			if (result.status === 200) {
				// console.log("Listofworksstudentone.js")
				// console.log(JSON.stringify(result))
				let datalist = [];
				var game_list = result.data.game_list

				for (var i = 0; i < game_list.length; i++) {

					datalist.push({
						number: "第" + game_list[i].position + "关",
						name: moment(game_list[i].end_time).format('YYYY-MM-DD HH:mm'),
						stduynumber: game_list[i].cost_time,
						classroom: game_list[i].score,
						complete_status: game_list[i].complete_status,
					})

				}
				// console.log("viewtraining");
				// console.log(datalist);
				// console.log(JSON.stringify(datalist));
				this.setState({
					viewtrainingdata: result.data,
					visibles: true,
					game_list: datalist
				})
			}
		}).catch((error) => {

		})
	}

	// 关闭调分
	cancelModulationModels = () => {
		this.setState({visibles: false})
	}
	//排序
	funorder = (e) => {
		if (e === "updated_at") {
			// 时间
			// 时间排序是从小到大
			this.setState({
				order: "updated_at",
				loadingstate: true,
			})
			this.Getalistofworkstwo(e, "", "", "", this.state.page, this.state.limit);
		}

		if (e === "work_score") {
			// 成绩
			//成绩排序是从大到小
			this.setState({
				order: "work_score",
				loadingstate: true,
			})
			this.Getalistofworkstwo(e, "", "", "", this.state.page, this.state.limit);
		}

		if (e === "student_id") {
			//学号
			//学号排序是从大到小
			this.setState({
				order: "student_id",
				loadingstate: true,
			})
			this.Getalistofworkstwo(e, "", "", "", this.state.page, this.state.limit);
		}
	}

	Startsorting = (ordervlue, checkedValuesine, checkedValuesineinfo, searchtext, page, limit) => {
		// console.log("获取作品列表Listofworksstudenttwo");
		var homeworkid = this.props.match.params.homeworkid;
		let urll = `/homework_commons/${homeworkid}/works_list.json`;
		// console.log(homeworkid);

		// search:搜索关键字
		// order:排序方式：更新时间：update_time，最终成绩：work_score，学号：student_id
		// b_order:desc：倒序 ， asc：顺序
		// work_status:0:未提交， 1:按时提交， 2:延时提交，“”不限
		// course_group:分班情况 [232, 231]， []:不限（空数组）
		var order = "asc";
		if (ordervlue === "updated_at") {
			order = "desc";
		}
		var data = {
			search: "",
			order: ordervlue,
			b_order: order,
			work_status: "",
			course_group: "",
			page: page,
			limit: limit,

		}
		axios.post(urll, data).then((result) => {
			if(result !== undefined){
				// console.log("学生公开的作品列表")
				// console.log(JSON.stringify(result))
				this.setState({
					teacherdata: result.data,
					task_status: result.data.task_status,
					course_group_info: result.data.course_group_info,
					student_works: result.data.student_works,
					loadingstate: false
				})
				this.seacthdata();
			}
		}).catch((error) => {
			console.log(error)
			this.setState({
				loadingstate: false
			})
		})

	}

	TablePagination = (e) => {
		// console.log(e.current);
		var teacherlists = {  //分页
			total: this.state.student_works.length, //数据总数量
			pageSize: 10,  //一页显示几条
			current: e.current,
		}
		this.setState({
			page: e.current,
			teacherlists: teacherlists
		})

	}


	paginationonChanges = (pageNumber) => {
		this.setState({
			page: pageNumber,
			loadingstate: true,
		})
		this.Getalistofworkstwo(this.state.order, "", "", "", pageNumber, this.state.limit);
	}

	render() {
		let {visibles, game_list, limit, viewtrainingdata, teacherdata,page, data, jobsettingsdata,styletable, datas, order, loadingstate} = this.state;
		let columns = [
			{
				title: '序号',
				dataIndex: 'number',
				key: 'number',
				align: "center",
				width:'96px',
				render: (text, record) => (
					<span>
             <a style={{
							 "color": '#07111B',
							 "text-align": "center"
						 }}>{record.number === undefined ? "--" : record.number === "" ? "--" : record.number}</a>
        </span>
				),
			},
			{
				title: '姓名',
				dataIndex: 'name',
				key: 'name',
				align: "center",
				width:'147px',
				render: (text, record) => (
					<span>
             <a style={{
							 "color": '#07111B',
							 "text-align": "center"
						 }}>{record.name === undefined ? "--" : record.name === "" ? "--" : record.name === null ? "--" : record.name}</a>
        </span>
				),
			},
			{
				title: '学号',
				dataIndex: 'stduynumber',
				key: 'stduynumber',
				align: "center",
				width:'200px',
				render: (text, record) => (
					<span>
             <a style={{
							 "color": '#9A9A9A',
							 "text-align": "center"
						 }}>{record.stduynumber === undefined ? "--" : record.stduynumber === null ? "--" : record.stduynumber === "" ? "--" : record.stduynumber}</a>
        </span>
				),
			},
			{
				title: '分班',
				key: 'classroom',
				dataIndex: 'classroom',
				align: "center",
				render: (text, record) => (
					<span>
             <a style={{
							 "color": '#9A9A9A',
							 "text-align": "center"
						 }}>{record.classroom === undefined ? "--" : record.classroom === "" ? "--" : record.classroom === null ? "--" : record.classroom}</a>
        </span>
				),
			},
			{
				title: '提交状态',
				dataIndex: 'submitstate',
				key: 'submitstate',
				align: "center",
				render: (text, record) => (
					<span>
 <a style={record.submitstate === "延时提交" ? {
	 "color": '#DD1717',
	 "text-align": "center"
 } : record.submitstate === "按时提交" ? {"color": '#29BD8B', "text-align": "center"} : {
	 "color": '#747A7F',
	 "text-align": "center"
 }}>{record.submitstate === undefined ? "--" : record.submitstate === "" ? "--" : record.submitstate === null ? "--" : record.submitstate}</a>

        </span>
				),
			},
			{
				title: '更新时间',
				dataIndex: 'updatetime',
				key: 'updatetime',
				align: "center",
				render: (text, record) => (
					<span>
             <a style={{
							 "color": '#9A9A9A',
							 "text-align": "center"
						 }}>{record.updatetime === undefined ? "--" : record.updatetime === "" ? "--" : record.updatetime}</a>
        </span>
				),
			},
			{
				title: '完成情况',
				dataIndex: 'completion',
				key: 'completion',
				align: "center",
				render: (text, record) => (
					<span>
             <a style={{
							 "color": '#9A9A9A',
							 "text-align": "center"
						 }}>{record.completion === undefined ? "--" : record.completion === "" ? "--" : record.completion}</a>
        </span>
				),
			},
			{
				title: '最终成绩',
				dataIndex: 'levelscore',
				key: 'levelscore',
				align: "center",
				render: (text, record) => (
					<span>
                          <a style={parseInt(record.levelscore) > 90 ? {
														"color": '#DD1717',
														"text-align": "center"
													} : parseInt(record.levelscore) <= 90 ? {
														"color": '#FF6800',
														"text-align": "center",
														"margin-left": "20px"
													} : parseInt(record.levelscore) <= 60 ? {
														"color": '#747A7F',
														"text-align": "center"
													} : {"color": '#747A7F', "text-align": "center"}}>{record.levelscore}</a>
        </span>
				),
			},
			{
				title: '操作',
				dataIndex: 'operating',
				key: 'operating',
				align: "center",
				width:'96px',
				render: (text, record) => (
					<span>
                        {
													record.submitstate === "未提交" ? "--"
														:
														<a style={{"text-align": "center"}}
															 className="color-blue"
															 onClick={() => this.Viewstudenttraininginformation(record)}>{record.operating}</a>
												}

        </span>
				),
			},
		];
		// console.log("teacherdatateacherdatateacherdata");
		// console.log(teacherdata);
		// console.log("teacherdata.work_count");
		// console.log(teacherdata&&teacherdata.work_count);
		return (
			teacherdata === undefined || teacherdata.student_works === undefined || teacherdata.student_works === null || JSON.stringify(teacherdata.student_works) === "[]" ?
				// 学生不能查看别人的
				<div className="newMain clearfix ">
					{visibles === true ?
						<div>
							<style>
								{
									`
              body {
         overflow: hidden !important;
       }
              `
								}
							</style>
							<TraineetraininginformationModal
								homeworkid={this.props.match.params.homeworkid}
								coursesId={this.props.match.params.coursesId}
								userids={this.state.userids}
								viewtrainingdata={viewtrainingdata}
								game_list={game_list}
								visible={visibles}
								Cancel={() => this.cancelModulationModels()}
							/>
						</div>
					 : ""
					}

					<div className={"educontent mb20"}>
						<div className="educontent mb30">
							<p className="clearfix mb20 mt10">
								<ActionBtn className=" btn colorgrey fl hovercolorblue "
													 to={`/courses/${this.props.match.params.coursesId}/students`}>{jobsettingsdata === undefined ? "" : jobsettingsdata.data.course_name}</ActionBtn>
								<span className="color-grey-9 fl ml3 mr3">&gt;</span>
								<ActionBtn
									className=" btn colorgrey fl hovercolorblue "
									to={`/courses/${this.props.match.params.coursesId}/${this.state.shixuntypes}/${jobsettingsdata === undefined ? "" : jobsettingsdata.data.category.category_id===undefined?"" :jobsettingsdata.data.category.category_id}`}>{jobsettingsdata === undefined ? "" : jobsettingsdata.data.category.category_name}</ActionBtn>
								<span className="color-grey-9 fl ml3 mr3">&gt;</span>
								<WordsBtn className="fl">作业详情</WordsBtn>
							</p>
						</div>
						<div className="educontent mb30">
							<p className=" fl color-black  summaryname">
								{teacherdata === undefined ? "" : teacherdata.homework_name}
							</p>
							<CoursesListType
								typelist={teacherdata === undefined ? [""] : teacherdata.homework_status}
							/>
							<a className="color-grey-9 fr font-16  summaryname  ml20 mr20"
								 href={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${jobsettingsdata === undefined ? "" :jobsettingsdata.data.category.category_id}`}>返回</a>
							<p className="color-grey-9 fr font-16"></p>

						</div>
						<div className="edu-back-white">
							<div className="stud-class-set bor-bottom-greyE ">
								<div className=" clearfix edu-back-white poll_list">
									<Link className="active"
												to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/openlist`}>作品列表</Link>
									<Link
										to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/questions`}>作业问答</Link>
									<Link
										to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/settings`}
									>设置</Link>
									<Link className="fr color-blue font-16" target={"_blank"}
												to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${teacherdata === undefined ? "" : teacherdata.id}/shixun_work_report`}>
										查看实训报告
									</Link>
									{/*<a className="fr color-blue font-16">查看实训报告</a>*/}
									{
										teacherdata === undefined ? ""
											: teacherdata.commit_des === null || teacherdata.commit_des === undefined ? "" :
											<a className="fr color-blue font-16"
												 href={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${teacherdata === undefined ? "" : teacherdata.id}/commitsummary/${this.state.props.match.params.homeworkid}`}>{teacherdata.commit_des}</a>
									}
									{teacherdata === undefined ? "" : <Startshixuntask
										{...this.props}
										data={teacherdata}
									/>}
								</div>
							</div>


							{JSON.stringify(data) !== "[]" ?
								<div>
									<div id="graduation_work_list"
											 style={{
												 "padding": '0px 20px 10px 20px',
												 "margin-top": "20px",
												 "margin-bottom": "10px"
											 }}>

										<div className="clearfix">
                                <span className="fl color-grey-6 font-12"><span
																	className="color-orange-tip">{teacherdata === undefined ? "" : teacherdata.commit_count === undefined ? "" : teacherdata.commit_count}</span>已交<span
																	className="ml10">{teacherdata === undefined ? "" : teacherdata.uncommit_count}</span><span>未交</span>
																	{teacherdata === undefined ? "" : teacherdata.left_time === undefined ? "" :teacherdata.left_time === null ? "" :
																		<span className="ml20">{teacherdata.left_time.status}</span>
																	}
																	{teacherdata === undefined ? "0" : teacherdata.left_time === undefined ? "0" : teacherdata.left_time === null ? "0" :
																		<span className="ml20" style={{"color": '#FF6800'}}>{teacherdata.left_time.time}</span>
																	}
                                </span>

										</div>

									</div>
									<div className={"justify break_full_word new_li edu-back-white"}
											 style={{minHeight: "480px"}}>
										<style>{`
              	          .ant-spin-nested-loading > div > .ant-spin .ant-spin-dot {
																			top: 72%;}
						                }
						              `}</style>
										<div className="edu-table edu-back-white ">
											{data === undefined ? "" : <Table
												dataSource={data}
												columns={columns}
												pagination={false}
												loading={false}
											/>}
										</div>
									</div>
								</div>

								:
								<div id="forum_list" className="forum_table">
									<div className="mh650 edu-back-white">
										<div className="edu-tab-con-box clearfix edu-txt-center">
											<img className="edu-nodata-img mb20"
													 src={getImageUrl("images/educoder/nodata.png")}/>
											<p className="edu-nodata-p mb30">没有数据可以显示！</p>
										</div>
									</div>

								</div>
							}

						</div>

					</div>

				</div>
				:
				// 学生能查看别人的
				<div className="newMain clearfix ">
					{visibles === true ?
						<TraineetraininginformationModal
							homeworkid={this.props.match.params.homeworkid}
							coursesId={this.props.match.params.coursesId}
							userids={this.state.userids}
							viewtrainingdata={viewtrainingdata}
							game_list={game_list}
							visible={visibles}
							Cancel={() => this.cancelModulationModels()}
						/> : ""
					}
					<div className={"educontent mb20"}>
						<div className="educontent mb30">
							<p className="clearfix mb20 mt10">
								<ActionBtn className=" fl "
													 to={`/courses/${this.props.match.params.coursesId}`}>{jobsettingsdata === undefined ? "" : jobsettingsdata.data.course_name}</ActionBtn>
								<span className="color-grey-9 fl ml3 mr3">&gt;</span>
								<ActionBtn
									className=" fl "
									to={`/courses/${this.props.match.params.coursesId}/${this.state.shixuntypes}/${jobsettingsdata === undefined ? "" : jobsettingsdata.data.category.category_id}`}>{jobsettingsdata === undefined ? "" : jobsettingsdata.data.category.category_name}</ActionBtn>
								<span className="color-grey-9 fl ml3 mr3">&gt;</span>
								<WordsBtn className="fl">作业详情</WordsBtn>
							</p>
						</div>
						<div className="educontent mb30">
							<p className=" fl color-black  summaryname">
								{jobsettingsdata === undefined ? "" : jobsettingsdata.data.homework_name}
							</p>
							<CoursesListType
								typelist={jobsettingsdata === undefined ? [""] : jobsettingsdata.data.homework_status}
							/>
							<p className="color-grey-6 fr font-16  summaryname  ml20"
								 onClick={() => this.props.history.goBack()}>返回</p>
							<p className="color-grey-6 fr font-16"></p>

						</div>
						<div className="edu-back-white">
							<div className="stud-class-set bor-bottom-greyE ">
								<div className=" clearfix edu-back-white poll_list">
									<Link className="active"
												to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/openlist`}>作品列表</Link>
									<Link
										to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/questions`}>作业问答</Link>
									<Link
										to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/settings`}
									>设置</Link>
									<Link className="fr color-blue font-16" target={"_blank"}
												to={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${this.state.props.match.params.homeworkid}/shixun_work_report`}>
										查看实训报告
									</Link>
									{
										teacherdata === undefined ? ""
											: teacherdata.commit_des === null || teacherdata.commit_des === undefined ? "" :
											<a className="fr color-blue font-16"
												 href={`/courses/${this.state.props.match.params.coursesId}/${this.state.shixuntypes}/${teacherdata === undefined ? "" : teacherdata.id}/commitsummary/${this.state.props.match.params.homeworkid}`}>{teacherdata.commit_des}</a>
									}
									{teacherdata === undefined ? "" : <Startshixuntask
										{...this.props}
										data={teacherdata}
									/>}
								</div>
							</div>


							{/*<div id="graduation_work_list" style={{padding: '0px 40px 10px 40px'}}>*/}

							{/*    <div className="clearfix">*/}
							{/*        <span className="fl color-grey-6 font-12"><span className="color-orange-tip">89</span>已交<span*/}
							{/*            className="ml10">9000</span><span>未交</span>    <span className="ml20">剩余提交时间:</span><span*/}
							{/*            className="ml20">{this.state.day}天 {this.state.hour}:{this.state.minute}:{this.state.second}</span></span>*/}

							{/*    </div>*/}

							{/*</div>*/}
							<div className="edu-table edu-back-white ">
								{data === undefined ? "" : <Table
									style={styletable}
									dataSource={data}
									columns={columns}
									pagination={false}
									loading={false}
									showHeader={false}
									scroll={{y: 240}}
								/>}
							</div>
							{JSON.stringify(datas) !== "[]" ?
								<div>
									<div id="graduation_work_list" style={{
										"padding": '0px 20px 10px 20px',
										"margin-top": "20px",
										"margin-bottom": "10px"
									}}>
										<div className="clearfix">
                              <span className="fl color-grey-6 font-12"><span
																className="color-orange-tip">{teacherdata === undefined ? "" : teacherdata.commit_count === undefined ? "" : teacherdata.commit_count}</span>已交<span
																className="ml10">{teacherdata === undefined ? "" : teacherdata.uncommit_count}</span><span>未交</span>
																{teacherdata === undefined ? "" : teacherdata.left_time === undefined ? "" : teacherdata.left_time === null ? "" :<span className="ml20">{teacherdata.left_time.status}</span>}
																{teacherdata === undefined ? "0" : teacherdata.left_time === undefined ? "0" :teacherdata.left_time === null ? "0" :<span className="ml20" style={{"color": '#FF6800'}}>{teacherdata.left_time.time}</span> }

                              </span>
											<div className="fr color-grey-6 edu-menu-panel">
												<ul>
													<li className="edu-position edu-position-hidebox">
														<a className="font-12 color-grey-6">
															{order === "updated_at" ? "时间" : order === "work_score" ? "成绩" : order === "student_id" ? "学号" : ""}排序</a>
														<i className="iconfont icon-xiajiantou ml5 font-12 color-grey-6"></i>
														<ul className="edu-position-hide undis mt10">
															<li> <a  onClick={(e) => this.funorder("updated_at")} data-remote="true" className="color-grey-6 font-12" style={{"text-align": "center "}}>更新时间</a></li>
															<li> <a  onClick={(e) => this.funorder("work_score")} data-remote="true" className="color-grey-6 font-12" style={{"text-align": "center "}}>最终成绩</a></li>
															<li> <a  onClick={(e) => this.funorder("student_id")} data-remote="true" className="color-grey-6 font-12" style={{"text-align": "center "}}>学生学号</a></li>
														</ul>
													</li>
												</ul>
											</div>

										</div>

									</div>

									<div className={"justify break_full_word new_li edu-back-white"}
											 style={{minHeight: "480px"}}>
										<style>{`
              	          .ant-spin-nested-loading > div > .ant-spin .ant-spin-dot {
																			top: 72%;}
						                }
						              `}</style>
										<div className="edu-table edu-back-white ">
											{datas === undefined ? "" : <Table
												dataSource={datas}
												columns={columns}
												pagination={false}
												loading={loadingstate}
												onChange={this.TablePagination}
											/>}
										</div>
										{
											teacherdata && teacherdata.work_count && teacherdata.work_count > limit ?
												<div className="edu-txt-center mt30 mb20">
													<Pagination showQuickJumper current={page}
																			onChange={this.paginationonChanges} pageSize={limit}
																			total={teacherdata.work_count}></Pagination>
												</div>
												: ""
										}
									</div>
								</div>
								:
								<div id="forum_list" className="forum_table">
									<div className="mh650 edu-back-white">
										<div className="edu-tab-con-box clearfix edu-txt-center">
											<img className="edu-nodata-img mb20"
													 src={getImageUrl("images/educoder/nodata.png")}/>
											<p className="edu-nodata-p mb30">没有数据可以显示！</p>
										</div>
									</div>

								</div>
							}


							{/*///*/}


						</div>

					</div>

				</div>


		)
	}
}

export default Listofworksstudentone;