import React, {Component} from "react";
import {WordsBtn} from 'educoder';
import { Form, Select, Input, Button,Checkbox,Upload,Icon,message,Modal, Table, Divider,InputNumber, Tag,DatePicker,Radio,Tooltip} from "antd";
import {Link,Switch,Route,Redirect} from 'react-router-dom';
import axios from 'axios';
import ConclusionEvaluation from './shixunreport/ConclusionEvaluation';
import OfficialAcademicTranscript from './shixunreport/OfficialAcademicTranscript';
import Coursesshixundetails from './shixunreport/Coursesshixundetails';
import Shixunechart from './shixunreport/Shixunechart';
import {UnControlled as CodeMirror} from 'react-codemirror2';
import 'codemirror/mode/cmake/cmake';
import 'codemirror/mode/xml/xml';
import 'codemirror/mode/javascript/javascript';
import 'codemirror/mode/clike/clike';

import '../css/members.css';
import "../common/formCommon.css";
import '../css/Courses.css';
import './style.css';


class ShixunWorkReport extends Component {

	constructor(props) {
		super(props);
		this.state = {
			data:undefined
		}
	}

	componentDidMount() {
		let homeworkid=this.props.match.params.homeworkid;
	    let url = `/student_works/${homeworkid}/shixun_work_report.json`
		axios.get(url).then((result) => {
				this.setState({
					data:result.data
				})

		}).catch((error) => {
			console.log(error)
		})
		let query = this.props.location.pathname;
		const type = query.split('/');
		this.setState({
			shixuntypes:type[3]
		})
	}

	render() {
		let{data} =this.state;
		let category_id=data===undefined?"":data.category.category_id;
		let homework_common_id=data===undefined?"":data.homework_common_id;
		let homeworkid=this.props.match.params.homeworkid;
		return (
			data===undefined?"":<div className="newMain clearfix ">
				<div className={"educontent mb20" }>
					<div className="educontent">
						<p className="clearfix mt20">
							<WordsBtn to={"/courses/"+this.props.match.params.coursesId+"/students"} className="fl color-grey-9" style="btn colorgrey fl hovercolorblue">
									<span className={"color-grey-9"}>	{data&&data.course_name}</span>
							</WordsBtn>
							<span className="color-grey-9 fl ml3 mr3">&gt;</span>
							<WordsBtn to={"/courses/"+this.props.match.params.coursesId+"/"+this.state.shixuntypes+"/"+category_id} style="grey" className="btn colorgrey fl hovercolorblue ">
									<span className={"color-grey-9"}>{data&&data.category.category_name}</span>
							</WordsBtn>
							<span className="color-grey-9 fl ml3 mr3">&gt;</span>
							<WordsBtn to={"/courses/"+this.props.match.params.coursesId+"/"+this.state.shixuntypes+"/"+homework_common_id+"/list"} className="fl color-grey-9">作业详情</WordsBtn>
							<span className="color-grey-9 fl ml3 mr3">&gt;</span>
							<WordsBtn className="fl">{data&&data.username}</WordsBtn>
						</p>
					</div>

					<div style={{ width:'100%',height:'75px'}} >
						<p className=" fl color-black mt25 summaryname">{data&&data.shixun_name}</p>
						{/*{this.props.isAdmin()?<a className=" fr font-14 ml30 mt10 mr20 color-grey-9 ">导出实训报告数据</a>:""}*/}
						{this.props.isAdmin() ? <a
							className="fr color-blue font-16"
							href={`
							/api/student_works/${homeworkid}/export_shixun_work_report.pdf
							`}
						>导出实训报告数据</a> : ""}
					</div>

					<div className="stud-class-set bor-bottom-greyE">
						<div className="clearfix edu-back-white poll_list">

							<div className="font-16 color-dark-21 shixunreporttitle ml20">总体评价</div>

              <ConclusionEvaluation
	              data={data}
              />

						</div>
					</div>

					<div className="stud-class-set">
						<div className="clearfix edu-back-white poll_list">

							<div className="font-16 color-dark-21 shixunreporttitle ml20">阶段成绩</div>

							<OfficialAcademicTranscript
								data={data}
							/>

						</div>
					</div>

					<div className="stud-class-set bor-bottom-greyE"
					      style={{display:data&&data.work_description===null?"none":""}}
					>
						<div className="clearfix edu-back-white poll_list">
							<div className="font-16 color-dark-21 shixunreporttitle ml20">个人总结</div>
							<style>
								{`
								.personalsummary{
										height:115px;
										border:1px solid rgba(235,235,235,1);
										border-radius:2px;
								}
								.pad040{
								    padding: 0px 40px 40px;
								}
								.pad40px{
										padding-bottom: 40px;
								}
								.codebox{
										height: 40px;
										line-height: 30px;
								 }
								 .codeboxright{
								    color: #999999!important;
								    font-size: 16px;
								 }
								`}
							</style>
							<div className={"pad040"}>
								<div className={"personalsummary"}>
									{data&&data.work_description}
								</div>
							</div>
						</div>
					</div>

					<div className="stud-class-set bor-bottom-greyE">
						<div className="clearfix edu-back-white poll_list">
							<div className="font-16 color-dark-21 shixunreporttitle ml20">图形统计</div>
							<Shixunechart
								data={data}
							/>
						</div>
					</div>

					<div className="stud-class-set bor-bottom-greyE">

						<div className="clearfix edu-back-white poll_list pad40px">
							<div className="font-16 color-dark-21 shixunreporttitle ml20">实训详情</div>
              <style>
	              {`
	              .poll_list a{
	              padding:0px !important;
	              }
	              .backgroud4CACFF{
	                  background: #4CACFF;
	              }
	              `}
              </style>
							{
								data&&data.shixun_detail===undefined?"":data.shixun_detail.map((item,key)=>{
									return(
										<div key={key} className={"mb20"}>
											<div className="font-16 color-dark-21 ml20 mr20">
												<p className="clearfix mb20">
									        <span className="panel-inner-icon mr15 fl mt3 backgroud4CACFF">
									            <i className="fa fa-code font-16 color_white"></i>
									        </span>
													<span className="fl mt3 font-14">
														<span className="font-bd mr15">第{item.position}关</span>
														<Link to={/tasks/+item.game_identifier}>
															<span className={"font-14"}>{item.subject}</span>
														</Link>
													</span>
												</p>
												<Coursesshixundetails
													data={item.outputs}
												/>
											</div>

											{item.st===0?<div className="font-16 color-dark-21 ml20 mr20">
												<div className="bor-grey-e mt15">
													<p className="clearfix pt5 pb5 pl15 pr15 back-f6-grey codebox">
														<span className="fl">最近通过的代码</span>
														<span className="fr codeboxright">{item.path}</span>
													</p>

													<div className="test-code bor-top-greyE">
														<li className="clearfix">
															<CodeMirror
																value={item.passed_code}
																options={{
																	// mode: 'xml',
																	theme: 'default',
																	lineNumbers: true,
																	// extraKeys: {"Ctrl-Q": "autocomplete"}, // 快捷键
																	indentUnit: 4, //代码缩进为一个tab的距离
																	matchBrackets: true,
																	autoRefresh: true,
																	smartIndent: true,//智能换行
																	styleActiveLine: true,
																	lint: true,
																	readOnly: "nocursor"
																}}
															/>
														</li>
													</div>
												</div>
											</div>:""}
								 </div>
								)
							})
							}
					</div>
					</div>

				</div>
			</div>

		)
	}
}

export default ShixunWorkReport;


