import React, { Component } from 'react';

import { BrowserRouter as Router, Route, Link, Switch } from "react-router-dom";

import Loading from '../../Loading';

import Loadable from 'react-loadable';

import { TPMIndexHOC } from '../tpm/TPMIndexHOC';

import { SnackbarHOC, getImageUrl } from 'educoder';
import AccountNav from './account/AccountNav'

const AccountBasic= Loadable({
  loader: () => import('./account/AccountBasic'),
  loading: Loading,
})
const AccountBasicEdit= Loadable({
  loader: () => import('./account/AccountBasicEdit'),
  loading: Loading,
})

const AccountCertification= Loadable({
  loader: () => import('./account/AccountCertification'),
  loading: Loading,
})
const AccountSecure= Loadable({
  loader: () => import('./account/AccountSecure'),
  loading: Loading,
})

class AccountPage extends Component {
    render() {
      const common = {}
      return (
          <div className="newMain clearfix accountPage">
            <style>{`
              .accountPage {
                display: flex;
              }
            `}</style>
            <AccountNav {...this.props}></AccountNav>
           
            <Switch {...this.props}>
              <Route exact path="/account/basic"
                      render={
                        (props) => (<AccountBasic {...this.props} {...props} {...this.state} {...common} />)
                      }
              ></Route>
              <Route exact path="/account/basic/edit"
                      render={
                        (props) => (<AccountBasicEdit {...this.props} {...props} {...this.state} {...common} />)
                      }
              ></Route>

              <Route exact path="/account/certification"
                      render={
                        (props) => (<AccountCertification {...this.props} {...props} {...this.state} {...common} />)
                      }
              ></Route>

              <Route exact path="/account/secure"
                      render={
                        (props) => (<AccountSecure {...this.props} {...props} {...this.state} {...common} />)
                      }
              ></Route>

              <Route exact path="/account"
                      render={
                        (props) => (<AccountBasic {...this.props} {...props} {...this.state} {...common} />)
                      }
              ></Route>
            </Switch>
        
          </div>
      );
    }
}

export default SnackbarHOC() ( TPMIndexHOC ( AccountPage ));
