import React, { Component } from 'react';

import { SnackbarHOC, getImageUrl, City } from 'educoder';
import { Form, Button, Input, Radio, Select, Tooltip, Icon  } from 'antd'
import ApplyForAddOrgModal from '../modal/ApplyForAddOrgModal'
import ApplyForAddChildOrgModal from '../modal/ApplyForAddChildOrgModal'

const RadioGroup = Radio.Group;
const Option = Select.Option
const radioOptions = [
  { label: '男', value: 'Apple' },
  { label: '女', value: 'Pear' },
];
class AccountBasic extends Component {
  handleSubmit = () => {
    this.props.form.validateFieldsAndScroll((err, values) => {
      if (!err) {

      }
    })
  }
  showApplyForAddOrgModal = () => {
    this.applyForAddOrgForm.setVisible(true)    
  }
  showApplyForAddChildOrgModal = () => {
    this.applyForAddChildOrgForm.setVisible(true)    
  }
  applyForAddChildOrgForm
  render() {
    const { getFieldDecorator } = this.props.form;
    const showRealName = false;
    return (
      <div className="basicFormWrap">
        <ApplyForAddOrgModal ref="applyForAddOrgModal" wrappedComponentRef={(form) => this.applyForAddOrgForm = form} ></ApplyForAddOrgModal>
        <ApplyForAddChildOrgModal ref="applyForAddChildOrgModal" wrappedComponentRef={(form) => this.applyForAddChildOrgForm = form} ></ApplyForAddChildOrgModal>
        
        <div className="basicForm">
          <style>{`
            .formItemInline {    
              display: flex;
            }
            .formItemInline .ant-form-item-control-wrapper {
              display: inline-block;
            }

            .basicForm {
              background: #fff;
              padding: 30px;
              width: 930px;
              margin: 20px;
              margin-bottom: 10px;
            }
              .basicForm .title {
                font-size: 16px;
                padding-left: 30px;
                margin-bottom: 10px;
              }
              .basicForm input, .basicForm .ant-input-affix-wrapper, .basicForm .ant-select {
                width: 400px;
                font-size: 14px;
              }
              .basicForm .saveBtn {
                width: 120px;
                margin-left: 100px;
              }
            .basicForm .ant-input-lg {
              height: 32px;
            }
            .basicForm .ant-form-item-label {
              width: 100px;
              padding-right: 10px;
            }
              .basicForm .ant-form-item-label label {
                color: #979797
              }
          `}</style>
          <div className="title">基本信息</div>

          <Form onSubmit={this.handleSubmit}>
            <Form.Item
              label="昵称"
              className="mt15 formItemInline"
            >
              {getFieldDecorator('nickname', {
                rules: [{
                  // initialValue: this.state.cityDefaultValue,
                  required: true, 
                  message: '请输入您的昵称',
                }],
              })(
                <Input placeholder="请输入您的昵称，10个字以内"></Input>
              )}
            </Form.Item>

            <Form.Item
              label="姓名"
              className="mt15 formItemInline"
            >
              {getFieldDecorator('name', {
                rules: [{
                  // initialValue: this.state.cityDefaultValue,
                  required: true, 
                  message: '请输入您的姓名',
                }],
              })(
                <Input placeholder="请输入您的姓名" suffix={
                  <Tooltip title="">
                    <Icon type="info-circle" style={{ color: 'rgba(0,0,0,.45)' }} />
                  </Tooltip>
                }></Input>
              )}
              <span>{ showRealName ? '（显示：平台将显示您的真实姓名）' : '（隐藏：平台将显示你的昵称）' }</span>
            </Form.Item>

            <Form.Item
              label="性别"
              className="mt15 formItemInline"
            >
              {getFieldDecorator('sex', {
                rules: [{
                  // initialValue: this.state.cityDefaultValue,
                  required: true, 
                  message: '',
                }],
              })(
                  <RadioGroup options={radioOptions} />
              )}
            </Form.Item>


            <Form.Item
              label="所在地"
              className="mt15 formItemInline"
            >
              {getFieldDecorator('city', {
                rules: [{
                  // initialValue: this.state.cityDefaultValue,
                  type: 'array',
                  required: true, 
                  message: '请先选择所在地',
                }],
              })(
                <City ></City>
              )}
            </Form.Item>

            <Form.Item
              label="职业"
              className="mt15 formItemInline"
            >
              {getFieldDecorator('job', {
                rules: [{
                  // initialValue: this.state.cityDefaultValue,
                  type: 'array',
                  required: true, 
                  message: '请先选择职业',
                }],
              })(
                <City ></City>
              )}
            </Form.Item>

            <Form.Item
              label="学校/单位"
              className="mt15 formItemInline mb0"
            >
              {getFieldDecorator('org', {
                rules: [{
                  // initialValue: this.state.cityDefaultValue,
                  // type: 'array',
                  required: true, 
                  message: '请先选择学校/单位',
                }],
              })(
                <Select width={400}>
                  <Option value="1">国防科技大学</Option>
                  <Option value="2">国防科技大学1</Option>
                </Select>
              )}
            </Form.Item>
            <div style={{marginLeft: '100px'}}>
              <span style={{color: '#CDCDCD'}}>未找到包含“Test”的高校，</span>
              <span style={{color: '#4CACFF', cursor: 'pointer'}} onClick={this.showApplyForAddOrgModal}>申请新增</span>
            </div>

            <Form.Item
              label="院系/部门"
              className="mt15 formItemInline mb0"
            >
              {getFieldDecorator('org2', {
                rules: [{
                  // initialValue: this.state.cityDefaultValue,
                  // type: 'array',
                  required: true, 
                  message: '请先选择院系/部门',
                }],
              })(
                <Select width={400}>
                  <Option value="1">计算机学院</Option>
                  <Option value="2">数学学院</Option>
                </Select>
              )}
            </Form.Item>
            <div style={{marginLeft: '100px'}}>
              <span style={{color: '#CDCDCD'}}>未找到包含“Test”的院系/部门，</span>
              <span style={{color: '#4CACFF', cursor: 'pointer'}} onClick={this.showApplyForAddChildOrgModal}>申请新增</span>
            </div>

                {/* htmlType="submit"  */}
            {/* <Form.Item>
              <div className="clearfix mt30 mb30"> */}
                <Button type="primary" onClick={this.handleSubmit} size="middle" className="saveBtn mr20 mt30">{"保存"}</Button>
              {/* </div>
            </Form.Item> */}
          </Form>
          </div>
          <diV style={{color: '#989898', marginLeft: '20px'}}>* 我们确保你所提供的信息均处于严格保密状态，不会泄露</diV>
      </div>
    );
  }
}
const WrappedAccountBasic = Form.create({ name: 'AccountBasic' })(AccountBasic);

export default WrappedAccountBasic;
