import React, { Component } from 'react';

import { SnackbarHOC, getImageUrl, WordsBtn } from 'educoder';
import { Form, Button, Input   } from 'antd'

import '../../courses/css/Courses.css'
import './common.css'
const PHONE = 'PHONE'
const EMAIL = 'EMAIL'
const PASSWORD = 'PASSWORD'
class AccountSecure extends Component {
  constructor (props) {
    super(props)
    this.state = {
      updating: ''
    }
  }
  onPhoneSubmit = () => {
    this.props.form.validateFieldsAndScroll((err, values) => {
      if (!err) {

      }
    })
  }
  onEmailSubmit = () => {
    this.props.form.validateFieldsAndScroll((err, values) => {
      if (!err) {

      }
    })
  }
  onPasswordSubmit = () => {
    this.props.form.validateFieldsAndScroll((err, values) => {
      if (!err) {

      }
    })
  }
  render() {
    const { getFieldDecorator } = this.props.form;
    const { updating } = this.state
    return (
      <div className="basicFormWrap">

        <div className="basicForm settingForm">
          <style>{`

            .flexRow {
              padding: 20px 0;
            }
              .flexRow .name {
                margin-left: 12px;
                color: #999999;

                text-align: center;
                flex: 0 0 100px;
              }
              .flexRow .description {
                margin-left: 10px;
                flex: 1;
                color: #CDCDCD;
              }
                .description span {
                  margin-right: 8px;
                  color: #05101A;
                }
              .flexRow .status {
                width: 100px;
                color: #28AC7F;
                text-align: right;
              }
            .flexTable .flexTable {
              padding-bottom: 24px;
              border-bottom: 1px solid #EBEBEB;
            }
            

            .settingForm label{
              color: #999999;
              font-size: 14px !important ; 
              margin-left: 120px;
            }
            .settingForm input {
              width: 340px;
            }
            .settingForm input.validateInput  {
              width: 220px;
            }
            .settingForm .formItemInline button {
              width: 110px;
              margin-left: 10px;
            }

            .settingForm .ant-form-item-label {
              width: 204px;
            }
          `}</style>
          <div className="title">安全设置</div>
          <Form>
          <div className="flexTable">
            <div className="flexTable">
              <div className="flexRow">
                <div className="name">手机</div>
                {/* #EA320E 
                  仅自己可见，可用于手机号码登录EduCoder
                */}
                <div className="description">
                  <span style={{color: '#EA320E'}}>未绑定</span>
                  绑定手机号码，将获得500金币的奖励哟～，手机号码仅自己可见~ 
                </div>
                <div className="status">
                  <WordsBtn style="blue" className="borderBottom" 
                      onClick={() => this.setState({updating: PHONE})}
                  >立即绑定</WordsBtn>
                </div>
              </div>
              
              { updating == PHONE && 
              <React.Fragment>
              <Form.Item
                label="你的手机号"
                className="mt15 formItemInline hideRequireTag mb0"
              >
                {getFieldDecorator('phone', {
                  rules: [{
                    // initialValue: this.state.cityDefaultValue,
                    required: true, 
                    message: '请输入要绑定的手机号码',
                  }],
                })(
                  <Input placeholder="请输入要绑定的手机号码"></Input>
                )}
              </Form.Item>

              <Form.Item
                label="手机验证码"
                className="mt15 formItemInline hideRequireTag"
              >
                {getFieldDecorator('phoneValidateCode', {
                  rules: [{
                    // initialValue: this.state.cityDefaultValue,
                    required: true, 
                    message: '请输入手机获取的验证码',
                  }],
                })(
                  <Input placeholder="请输入手机获取的验证码" className="validateInput"></Input>
                )}
                <Button type="primary">获取验证码</Button>
              </Form.Item>

              <div style={{ marginLeft: '118px' }}>
                <Button type="primary" onClick={this.onPhoneSubmit}>确定</Button>
                <Button type="primary grayBtn" style={{ marginLeft: '20px'}}>取消</Button>
              </div>
              </React.Fragment> }
            </div>
            
            <div className="flexTable">
              <div className="flexRow">
                <div className="name">邮箱</div>
                <div className="description">
                  <span>kuc***w@126.com</span>
                  邮箱账号仅自己可见，可用于邮箱账号登录EduCoder 
                </div>
                <div className="status">
                  <WordsBtn style="blue" className="borderBottom"
                    onClick={() => this.setState({updating: EMAIL})}
                  >更换</WordsBtn>
                </div>
              </div>  
              
              { updating == EMAIL && 
              <React.Fragment>
              <Form.Item
                label="邮箱地址"
                className="mt15 formItemInline hideRequireTag mb0"
              >
                {getFieldDecorator('phone', {
                  rules: [{
                    // initialValue: this.state.cityDefaultValue,
                    required: true, 
                    message: '请输入要更换的新邮箱地址',
                  }],
                })(
                  <Input placeholder="请输入要更换的新邮箱地址"></Input>
                )}
              </Form.Item>

              <Form.Item
                label="邮箱验证码"
                className="mt15 formItemInline hideRequireTag"
              >
                {getFieldDecorator('phoneValidateCode', {
                  rules: [{
                    // initialValue: this.state.cityDefaultValue,
                    required: true, 
                    message: '请输入邮箱收到的验证码',
                  }],
                })(
                  <Input placeholder="请输入邮箱收到的验证码" className="validateInput"></Input>
                )}
                <Button type="primary">获取验证码</Button>
              </Form.Item>

              <div style={{ marginLeft: '118px' }}>
                <Button type="primary">确定</Button>
                <Button type="primary grayBtn" style={{ marginLeft: '20px'}}>取消</Button>
              </div>
              </React.Fragment>  }

            </div>


            <div className="flexTable">
              <div className="flexRow">
                <div className="name">密码</div>
                <div className="description">
                  <span>**********</span>
                  用于保护账户信息和登录安全 
                </div>
                <div className="status">
                  <WordsBtn style="blue" className="borderBottom"
                      onClick={() => this.setState({updating: PASSWORD})}
                  >修改</WordsBtn>
                </div>
              </div> 
              
              { updating == PASSWORD && 
              <React.Fragment>
              <Form.Item
                label="旧密码"
                className="mt15 formItemInline hideRequireTag mb0"
              >
                {getFieldDecorator('p_old', {
                  rules: [{
                    // initialValue: this.state.cityDefaultValue,
                    required: true, 
                    message: '请设置8～16位密码，区分大小写',
                  }],
                })(
                  <Input type="password" placeholder="请设置8～16位密码，区分大小写"></Input>
                )}
              </Form.Item>

              <Form.Item
                label="新密码"
                className="mt15 formItemInline hideRequireTag mb0"
              >
                {getFieldDecorator('p_new', {
                  rules: [{
                    // initialValue: this.state.cityDefaultValue,
                    required: true, 
                    message: '请设置8～16位密码，区分大小写',
                  }],
                })(
                  <Input type="password" placeholder="请设置8～16位密码，区分大小写" className="validateInput"></Input>
                )}
              </Form.Item>

              <Form.Item
                label="再次输入"
                className="mt15 formItemInline hideRequireTag"
              >
                {getFieldDecorator('p_again', {
                  rules: [{
                    // initialValue: this.state.cityDefaultValue,
                    required: true, 
                    message: '请再次输入新密码',
                  }],
                })(
                  <Input type="password" placeholder="请再次输入新密码" className="validateInput"></Input>
                )}
              </Form.Item>

              <div style={{ marginLeft: '118px' }}>
                <Button type="primary" onClick={this.onPasswordSubmit}>确定</Button>
                <Button type="primary grayBtn" style={{ marginLeft: '20px'}}>取消</Button>
              </div>
              </React.Fragment> }
            </div>

          </div>
          </Form>
        </div>
        <diV style={{color: '#989898', marginLeft: '20px'}}>* 我们确保你所提供的信息均处于严格保密状态，不会泄露</diV>
      </div>
    );
  }
}
const WrappedAccountSecure = Form.create({ name: 'AccountSecure' })(AccountSecure);

export default WrappedAccountSecure;
