import React, { Component } from "react";
import { message, Icon, Input, Form, Upload} from "antd";
import axios from 'axios'
import ModalWrapper from "../../courses/common/ModalWrapper"
import { City, getUploadActionUrl } from 'educoder'
import '../account/common.css'

const { TextArea } = Input;
const Dragger = Upload.Dragger;
function getBase64(img, callback) {
  const reader = new FileReader();
  reader.addEventListener('load', () => callback(reader.result));
  reader.readAsDataURL(img);
}
function beforeUpload(file) {
  const isJPG = file.type === 'image/jpeg';
  if (!isJPG) {
    message.error('You can only upload JPG file!');
  }
  const isLt2M = file.size / 1024 / 1024 < 2;
  if (!isLt2M) {
    message.error('Image must smaller than 2MB!');
  }
  return isJPG && isLt2M;
}
class RealNameCertificationModal extends Component{
  constructor(props){
    super(props);
    this.state={
      
    }
  }

  componentDidMount() {
    
  }
  setVisible = (visible) => {
    this.refs.modalWrapper.setVisible(visible)
  }

  onSendOk = () => {
   

  }

  onOk = () => {
    const { course_lists, checkBoxValues } = this.state
    this.onSendOk()
  }

  handleChange = (info) => {
    if (info.file.status === 'uploading') {
      this.setState({ loading: true });
      return;
    }
    if (info.file.status === 'done') {
      // Get this url from response in real world.
      getBase64(info.file.originFileObj, imageUrl => this.setState({
        imageUrl,
        loading: false,
      }));
    }
  }
  handleChange2 = (info) => {
    if (info.file.status === 'uploading') {
      this.setState({ loading: true });
      return;
    }
    if (info.file.status === 'done') {
      // Get this url from response in real world.
      getBase64(info.file.originFileObj, imageUrl2 => this.setState({
        imageUrl2,
        loading: false,
      }));
    }
  }

  render(){
    const { course_lists, checkBoxValues, searchValue, loading, imageUrl, imageUrl2 } = this.state
    const { moduleName } = this.props
    const { getFieldDecorator } = this.props.form;
    const uploadProps = {
      name: 'file',
      multiple: true,
      showUploadList: false,
      action: getUploadActionUrl(),
      className: 'idPic-uploader first_uploader',
      onChange: this.handleChange,
    };

    const uploadProps2 = {
      name: 'file',
      multiple: true,
      showUploadList: false,
      action: getUploadActionUrl(),
      className: 'idPic-uploader',
      onChange: this.handleChange2,
    };

    return(
      <ModalWrapper
        ref="modalWrapper"
        title={`实名认证`}
        {...this.props }
        onOk={this.onOk}
        okText="保存"
        className="modalForm"
        bottomRender={
          <div className="bottomRender">
            <p>认证须知：</p>
            <p>
              1.你需要准备有效的身份证正面（人像面）的证件照照片，请确保证件照片清晰可见，严禁PS；
            </p><p>
              2.我们将在你提交认证信息后的24小时（不包含节假日）内完成审核，审核结果将会以系统消息的形式发送给你； 
            </p><p>
              3.实名认证审核完成后，无法删除，请谨慎填写；
            </p><p>
              4.实名认证审核完成后，系统将自动发放500个金币作为奖励；
            </p><p>
              5.我们会确保你所提供的信息均处于严格的保密状态，不会泄露；
            </p><p>
              6.如存在恶意乱填写姓名，证件号，及上传与实名认证证件无关图片者，一经发现将冻结EduCoder账号。
            </p>
          </div>
        }
      >
        <style>{`
          .modalForm .ant-form-item-label {
            width: 100px;
            padding-right: 10px;
          }
          .modalForm .ant-form-item-label label {
            color: #979797
          }
          .formItemInline .ant-form-item-control-wrapper {
            width: 390px;
          }
          span.idPic-uploader {
            display: inline-block;
            padding: 20px;
            padding-bottom: 0px;

            width: 160px;
            height: 110px;

            margin: 0 16px;
          }
          .idPic-uploader > .ant-upload {
            width: 160px;
            height: 110px;
          }
          .idPic-uploader .ant-upload.ant-upload-drag p.ant-upload-drag-icon {
            margin-bottom: 0px;
          }
          .idPic-uploader .ant-upload.ant-upload-drag p.ant-upload-text {
            font-size: 12px;
          }
          .idPic-uploader .ant-upload.ant-upload-drag {
            padding: 0px
          }
          .idPic-uploader img {
            max-height: 110px;
            width: 160px;
          }
          .first_uploader {
            margin-left: 42px;
          }

          .bottomRender {
            padding: 19px;
            background: rgb(245,245,245);
            margin-top: 30px;
            color: #656565;
          }

          span.idPic-uploader.demoImg {
            display: flex;
            flex-direction: column;
            align-items: center;
          }
        `}</style>
        <Form>
          
          <Form.Item
            label="证件号："
            className="mt15 formItemInline"
          >
            {getFieldDecorator('re', {
              rules: [{
                // initialValue: this.state.cityDefaultValue,
                required: true, 
                message: '请输入证件号',
              }],
            })(
              <Input placeholder="请输入证件号" ></Input>
            )}
          </Form.Item>

          {/*  */}
          <div style={{ marginLeft: '18px' }}>
            <div>
              <span style={{color: '#999999'}}>身份证（人像面）上传</span>
              <span style={{color: '#FF6800'}}>（png/jpg/bmp格式，不超过2MB）</span>
            </div>

            <div
              style={{ display: 'flex', justifyContent: 'center', width: '94%', height: '140px' }}
            >
              <span className="idPic-uploader demoImg">
                <img src={"https://www.educoder.net/images/avatars/User/b?1532489442"} alt="avatar" style={{ maxHeight: '110px'}}/>
                <span style={{color: '#999999'}}>示例图片</span>
              </span>
              {/* <Dragger {...uploadProps} >
                {imageUrl ? 
                  <a href={imageUrl} target="_blank">
                    <img src={imageUrl} alt="avatar" style={{ maxHeight: '110px'}}/>
                  </a> : 
                  <React.Fragment>
                    <p className="ant-upload-drag-icon">
                      <Icon type="inbox" />
                    </p>
                    <p className="ant-upload-text">点击或拖拽上传图片</p>
                  </React.Fragment>
                }
              </Dragger> */}

              <Dragger {...uploadProps2}>
                {imageUrl2 ? 
                  <a href={imageUrl2} target="_blank">
                    <img src={imageUrl2} alt="avatar" style={{ maxHeight: '110px'}}/>
                  </a> : 
                  <React.Fragment>
                    <p className="ant-upload-drag-icon">
                      <Icon type="inbox" />
                    </p>
                    <p className="ant-upload-text">点击或拖拽上传图片</p>
                    {/* <p className="ant-upload-hint">Support for a single or bulk upload. Strictly prohibit from uploading company data or other band files</p> */}
                  </React.Fragment>
                }
              </Dragger>
            </div>
          </div>

          
        </Form>
        

      </ModalWrapper>
    )
  }
}
const WrappedRealNameCertificationModal = Form.create({ name: 'RealNameCertificationModal' })(RealNameCertificationModal);

export default WrappedRealNameCertificationModal;


